#pragma compress 1

#include <zombie_escape>
#include <engine>
#include <fakemeta_util>
#include <cstrike>
#include <fun>
#include <xs>

#pragma tabsize 0

#define ENG_NULLENT         -1

#define EV_INT_WEAPONKEY    EV_INT_impulse

#define scsr_WEAPONKEY      10018

#define MAX_PLAYERS         32

#define IsValidUser(%1) (1 <= %1 <= g_MaxPlayers)



const USE_STOPPED = 0

const OFFSET_ACTIVE_ITEM = 373

const OFFSET_WEAPONOWNER = 41

const OFFSET_LINUX = 5

const OFFSET_LINUX_WEAPONS = 4



#define WEAP_LINUX_XTRA_OFF     4

#define m_fKnown                    44

#define m_flNextPrimaryAttack       46

#define m_flTimeWeaponIdle          48

#define m_iClip                 51

#define m_fInReload             54

#define PLAYER_LINUX_XTRA_OFF   5

#define m_flNextAttack              83



#define scsr_RELOAD_TIME        4.0

#define scsr_SHOOT1             1

#define scsr_SHOOT2             2

#define scsr_RELOAD             3

#define scsr_DRAW               4



#define write_coord_f(%1)   engfunc(EngFunc_WriteCoord,%1)



new const Fire_Sounds[][] = { "weapons/starchasersr-1.wav" }



new scsr_V_MODEL[64] = "models/v_starchasersr.mdl"

new scsr_P_MODEL[64] = "models/p_starchasersr.mdl"

new scsr_W_MODEL[64] = "models/w_starchasersr.mdl"



new const scsr_name[] = "weapon_starchasersr"



new const scsr_spr[][] = 

{ 

    "sprites/640hud171.spr", 

    "sprites/640hud18.spr"

}



new const GUNSHOT_DECALS[] = { 41, 42, 43, 44, 45 }



new cvar_dmg_scsr, cvar_recoil_scsr, g_itemid_scsr, cvar_clip_scsr, cvar_spd_scsr, cvar_scsr_ammo

new g_MaxPlayers, g_orig_event_scsr, g_IsInPrimaryAttack

new Float:cl_pushangle[MAX_PLAYERS + 1][3]

new g_has_scsr[33], g_clip_ammo[33], g_scsr_TmpClip[33], oldweap[33]

new gmsgWeaponList, scsr_ball

new g_SprID

new Float:g_lastexpl[33]



const PRIMARY_WEAPONS_BIT_SUM = 

(1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<

CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)

new const WEAPONENTNAMES[][] = { "", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",

            "weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550",

            "weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",

            "weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",

            "weapon_ak47", "weapon_knife", "weapon_p90" }


public plugin_precache()

{

    precache_model(scsr_V_MODEL)

    precache_model(scsr_P_MODEL)

    precache_model(scsr_W_MODEL)

    for(new i = 0; i < sizeof Fire_Sounds; i++)

    precache_sound(Fire_Sounds[i])  

    precache_sound("weapons/starchasersr_clipin.wav")

    precache_sound("weapons/starchasersr_clipout.wav")

    precache_sound("weapons/starchasersr_idle.wav")



    g_SprID = precache_model("sprites/ef_starchasersr_explosion.spr")

    scsr_ball = precache_model("sprites/ef_starchasersr_star.spr")



    new sFile[64]

    formatex(sFile, charsmax(sFile), "sprites/%s.txt", scsr_name)

    precache_generic(sFile)

    

    for(new i = 0; i < sizeof(scsr_spr); i++)

    {

        precache_generic(scsr_spr[i])

    }



    register_forward(FM_PrecacheEvent, "fwPrecacheEvent_Post", 1)

}

public plugin_init()

{

    register_plugin("Star Chaser SR", "1.0", "[YouTube]COBA/Mark")

    register_message(get_user_msgid("DeathMsg"), "message_DeathMsg")

    register_event("CurWeapon","CurrentWeapon","be","1=1")

    RegisterHam(Ham_Item_AddToPlayer, "weapon_g3sg1", "fw_scsr_AddToPlayer")

    RegisterHam(Ham_Use, "func_tank", "fw_UseStationary_Post", 1)

    RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary_Post", 1)

    RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary_Post", 1)

    RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary_Post", 1)

    for (new i = 1; i < sizeof WEAPONENTNAMES; i++)

    if (WEAPONENTNAMES[i][0]) RegisterHam(Ham_Item_Deploy, WEAPONENTNAMES[i], "fw_Item_Deploy_Post", 1)

    RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_g3sg1", "fw_scsr_PrimaryAttack")

    RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_g3sg1", "fw_scsr_PrimaryAttack_Post", 1)

    RegisterHam(Ham_Item_PostFrame, "weapon_g3sg1", "scsr_ItemPostFrame")

    RegisterHam(Ham_Weapon_Reload, "weapon_g3sg1", "scsr_Reload")

    RegisterHam(Ham_Weapon_Reload, "weapon_g3sg1", "scsr_Reload_Post", 1)

    RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")

    register_forward(FM_SetModel, "fw_SetModel")

    register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)

    register_forward(FM_PlaybackEvent, "fwPlaybackEvent")



    RegisterHam(Ham_TraceAttack, "worldspawn", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_breakable", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_wall", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_door", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_door_rotating", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_plat", "fw_TraceAttack", 1)

    RegisterHam(Ham_TraceAttack, "func_rotating", "fw_TraceAttack", 1)



    cvar_dmg_scsr = register_cvar("ze_scsr_dmg", "2.0")

    cvar_recoil_scsr = register_cvar("ze_scsr_recoil", "1.90")

    cvar_clip_scsr = register_cvar("ze_scsr_clip", "15")

    cvar_spd_scsr = register_cvar("ze_scsr_spd", "2.48")

    cvar_scsr_ammo = register_cvar("ze_scsr_ammo", "120")

    

    g_itemid_scsr = ze_register_item("Star Chaser SR", 80, 0)

    g_MaxPlayers = get_maxplayers()

    gmsgWeaponList = get_user_msgid("WeaponList")

    register_clcmd(scsr_name, "command_scsr")

}

public ze_user_humanized(id)
{
    g_has_scsr[id] = false
}

public ze_user_infected(Victim)
{
    g_has_scsr[Victim] = false
}

public client_putinserver(id)
{
    g_has_scsr[id] = false
}

public client_disconnected(id)
{
    g_has_scsr[id] = false
}



public fw_TraceAttack(iEnt, iAttacker, Float:flDamage, Float:fDir[3], ptr, iDamageType, Player, id)

{

    if(!is_user_alive(iAttacker))

        return



    new g_currentweapon = get_user_weapon(iAttacker)



    if(g_currentweapon != CSW_G3SG1) return

    

    if(!g_has_scsr[iAttacker]) return



    static Float:flEnd[3]

    get_tr2(ptr, TR_vecEndPos, flEnd)



    if(iEnt)

    {

        message_begin(MSG_BROADCAST, SVC_TEMPENTITY)

        write_byte(TE_DECAL)

        write_coord_f(flEnd[0])

        write_coord_f(flEnd[1])

        write_coord_f(flEnd[2])

        write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])

        write_short(iEnt)

        message_end()

    }

    else

    {

        message_begin(MSG_BROADCAST, SVC_TEMPENTITY)

        write_byte(TE_WORLDDECAL)

        write_coord_f(flEnd[0])

        write_coord_f(flEnd[1])

        write_coord_f(flEnd[2])

        write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])

        message_end()

    }

    message_begin(MSG_BROADCAST, SVC_TEMPENTITY)

    write_byte(TE_GUNSHOTDECAL)

    write_coord_f(flEnd[0])

    write_coord_f(flEnd[1])

    write_coord_f(flEnd[2])

    write_short(iAttacker)

    write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])

    message_end()

}



public command_scsr(Player)

{

    engclient_cmd(Player, "weapon_g3sg1")

    return PLUGIN_HANDLED

}


public plugin_natives ()

{

    register_native("give_weapon_scsr", "native_give_weapon_add", 1)

}

public native_give_weapon_add(id)

{

    give_scsr(id)

}



public fwPrecacheEvent_Post(type, const name[])

{

    if (equal("events/g3sg1.sc", name))

    {

        g_orig_event_scsr = get_orig_retval()

        return FMRES_HANDLED

    }

    return FMRES_IGNORED

}




public fw_SetModel(entity, model[])

{

    if(!is_valid_ent(entity))

        return FMRES_IGNORED

    

    static szClassName[33]

    entity_get_string(entity, EV_SZ_classname, szClassName, charsmax(szClassName))

        

    if(!equal(szClassName, "weaponbox"))

        return FMRES_IGNORED

    

    static iOwner

    

    iOwner = entity_get_edict(entity, EV_ENT_owner)

    

    if(equal(model, "models/w_g3sg1.mdl"))

    {

        static iStoredAugID

        

        iStoredAugID = find_ent_by_owner(ENG_NULLENT, "weapon_g3sg1", entity)

    

        if(!is_valid_ent(iStoredAugID))

            return FMRES_IGNORED

    

        if(g_has_scsr[iOwner])

        {

            entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, scsr_WEAPONKEY)

            

            g_has_scsr[iOwner] = false

            

            entity_set_model(entity, scsr_W_MODEL)

            

            return FMRES_SUPERCEDE

        }

    }

    return FMRES_IGNORED

}



public give_scsr(id)

{

    drop_weapons(id, 1)

    new iWep2 = give_item(id,"weapon_g3sg1")

    if( iWep2 > 0 )

    {

        cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_scsr))

        cs_set_user_bpammo (id, CSW_G3SG1, get_pcvar_num(cvar_scsr_ammo))   

        UTIL_PlayWeaponAnimation(id, scsr_DRAW)

        set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)



        message_begin(MSG_ONE, gmsgWeaponList, _, id)

        write_string(scsr_name)

        write_byte(2)

        write_byte(90)

        write_byte(-1)

        write_byte(-1)

        write_byte(0)

        write_byte(3)

        write_byte(CSW_G3SG1)

        message_end()

    }

    g_has_scsr[id] = true

}



public ze_select_item_pre(id, itemid)
{   
    if (itemid != g_itemid_scsr)
        return ZE_ITEM_AVAILABLE
    
    if (ze_is_user_zombie(id))
        return ZE_ITEM_DONT_SHOW
        
    return ZE_ITEM_AVAILABLE
}

public ze_select_item_post(id, itemid)
{
    if (itemid != g_itemid_scsr)
        return
        
    ze_colored_print(id, "Congrats! You have bought Star Chaser SR! :D")
    
    give_scsr(id)
}

public fw_scsr_AddToPlayer(scsr, id)

{

    if(!is_valid_ent(scsr) || !is_user_connected(id))

        return HAM_IGNORED

    

    if(entity_get_int(scsr, EV_INT_WEAPONKEY) == scsr_WEAPONKEY)

    {

        g_has_scsr[id] = true

        

        entity_set_int(scsr, EV_INT_WEAPONKEY, 0)



        message_begin(MSG_ONE, gmsgWeaponList, _, id)

        write_string(scsr_name)

        write_byte(2)

        write_byte(90)

        write_byte(-1)

        write_byte(-1)

        write_byte(0)

        write_byte(3)

        write_byte(CSW_G3SG1)

        message_end()



        return HAM_HANDLED

    }

    else

    {

        message_begin(MSG_ONE, gmsgWeaponList, _, id)

        write_string("weapon_g3sg1")

        write_byte(2)

        write_byte(90)

        write_byte(-1)

        write_byte(-1)

        write_byte(0)

        write_byte(3)

        write_byte(CSW_G3SG1)

        message_end()

    }

    return HAM_IGNORED

}



public fw_UseStationary_Post(entity, caller, activator, use_type)

{

    if (use_type == USE_STOPPED && is_user_connected(caller))

        replace_weapon_models(caller, get_user_weapon(caller))

}



public fw_Item_Deploy_Post(weapon_ent)

{

    static owner

    owner = fm_cs_get_weapon_ent_owner(weapon_ent)

    

    static weaponid

    weaponid = cs_get_weapon_id(weapon_ent)

    

    replace_weapon_models(owner, weaponid)

}



public CurrentWeapon(id)

{

     replace_weapon_models(id, read_data(2))



     if(read_data(2) != CSW_G3SG1 || !g_has_scsr[id])

          return

     

     static Float:iSpeed

     if(g_has_scsr[id])

          iSpeed = get_pcvar_float(cvar_spd_scsr)

     

     static weapon[32],Ent

     get_weaponname(read_data(2),weapon,31)

     Ent = find_ent_by_owner(-1,weapon,id)

     if(Ent)

     {

          static Float:Delay

          Delay = get_pdata_float( Ent, 46, 4) * iSpeed

          if (Delay > 0.0)

          {

               set_pdata_float(Ent, 46, Delay, 4)

          }

     }

}



replace_weapon_models(id, weaponid)

{

    switch (weaponid)

    {

        case CSW_G3SG1:

        {       
            if(g_has_scsr[id])

            {

                set_pev(id, pev_viewmodel2, scsr_V_MODEL)

                set_pev(id, pev_weaponmodel2, scsr_P_MODEL)

                if(oldweap[id] != CSW_G3SG1) 

                {

                    UTIL_PlayWeaponAnimation(id, scsr_DRAW)

                    set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)



                    message_begin(MSG_ONE, gmsgWeaponList, _, id)

                    write_string(scsr_name)

                    write_byte(2)

                    write_byte(90)

                    write_byte(-1)

                    write_byte(-1)

                    write_byte(0)

                    write_byte(3)

                    write_byte(CSW_G3SG1)

                    message_end()

                }

            }

        }

    }

    oldweap[id] = weaponid

}



public fw_UpdateClientData_Post(Player, SendWeapons, CD_Handle)

{

    if(!is_user_alive(Player) || (get_user_weapon(Player) != CSW_G3SG1 || !g_has_scsr[Player]))

        return FMRES_IGNORED

    

    set_cd(CD_Handle, CD_flNextAttack, halflife_time () + 0.001)

    return FMRES_HANDLED

}



public fw_scsr_PrimaryAttack(Weapon)

{

    new Player = get_pdata_cbase(Weapon, 41, 4)

    

    if (!g_has_scsr[Player])

        return

    

    g_IsInPrimaryAttack = 1

    pev(Player,pev_punchangle,cl_pushangle[Player])

    

    g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)

}



public fwPlaybackEvent(flags, invoker, eventid, Float:delay, Float:origin[3], Float:angles[3], Float:fparam1, Float:fparam2, iParam1, iParam2, bParam1, bParam2)

{

    if ((eventid != g_orig_event_scsr) || !g_IsInPrimaryAttack)

        return FMRES_IGNORED

    if (!(1 <= invoker <= g_MaxPlayers))

    return FMRES_IGNORED



    playback_event(flags | FEV_HOSTONLY, invoker, eventid, delay, origin, angles, fparam1, fparam2, iParam1, iParam2, bParam1, bParam2)

    return FMRES_SUPERCEDE

}



public fw_scsr_PrimaryAttack_Post(Weapon)

{

    g_IsInPrimaryAttack = 0

    new iPlayer = get_pdata_cbase(Weapon, 41, 4)

    

    new szClip, szAmmo

    get_user_weapon(iPlayer, szClip, szAmmo)

    

    if(!is_user_alive(iPlayer))

        return



    if(g_has_scsr[iPlayer])

    {

        if (!g_clip_ammo[iPlayer])

            return



        new Float:push[3]

        pev(iPlayer,pev_punchangle,push)

        xs_vec_sub(push,cl_pushangle[iPlayer],push)

        

        xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_scsr),push)

        xs_vec_add(push,cl_pushangle[iPlayer],push)

        set_pev(iPlayer,pev_punchangle,push)

        

        emit_sound(iPlayer, CHAN_WEAPON, Fire_Sounds[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

        UTIL_PlayWeaponAnimation(iPlayer, random_num(scsr_SHOOT1, scsr_SHOOT2))



        static Float:plrViewAngles[3], Float:VecEnd[3], Float:VecDir[3], Float:PlrOrigin[3]

        pev(iPlayer, pev_v_angle, plrViewAngles)



        static Float:VecSrc[3], Float:VecDst[3]

    

        //VecSrc = pev->origin + pev->view_ofs

        pev(iPlayer, pev_origin, PlrOrigin)

        pev(iPlayer, pev_view_ofs, VecSrc)

        xs_vec_add(VecSrc, PlrOrigin, VecSrc)



        //VecDst = VecDir * 8192.0

        angle_vector(plrViewAngles, ANGLEVECTOR_FORWARD, VecDir)

        xs_vec_mul_scalar(VecDir, 8192.0, VecDst)

        xs_vec_add(VecDst, VecSrc, VecDst)

    

        new hTrace = create_tr2()

        engfunc(EngFunc_TraceLine, VecSrc, VecDst, 0, iPlayer, hTrace)

        get_tr2(hTrace, TR_vecEndPos, VecEnd)



        explode(iPlayer);

        scsr_spr_ball(iPlayer, VecSrc, VecEnd);

    }

}



public explode(id)

{

    if(is_user_alive(id))

    {       

        new Float:originF[3]

        fm_get_aim_origin(id, originF)

        message_begin(MSG_ALL, SVC_TEMPENTITY)

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0])

        engfunc(EngFunc_WriteCoord, originF[1])

        engfunc(EngFunc_WriteCoord, originF[2]+30.0)

        message_end()

        

        message_begin(MSG_ALL, SVC_TEMPENTITY)

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0]+30.0)

        engfunc(EngFunc_WriteCoord, originF[1])

        engfunc(EngFunc_WriteCoord, originF[2]+30.0)

        message_end()

        

        message_begin(MSG_ALL, SVC_TEMPENTITY) 

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0])

        engfunc(EngFunc_WriteCoord, originF[1]+30.0)

        engfunc(EngFunc_WriteCoord, originF[2]+30.0)

        message_end()

        

        message_begin(MSG_ALL, SVC_TEMPENTITY)

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0])

        engfunc(EngFunc_WriteCoord, originF[1]+40.0)

        engfunc(EngFunc_WriteCoord, originF[2]+40.0)

        message_end()

        

        message_begin(MSG_ALL, SVC_TEMPENTITY)

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0])

        engfunc(EngFunc_WriteCoord, originF[1]+40.0)

        engfunc(EngFunc_WriteCoord, originF[2]+30.0)

        message_end()

        

        message_begin(MSG_ALL, SVC_TEMPENTITY)

        write_byte(TE_SPARKS)

        engfunc(EngFunc_WriteCoord, originF[0])

        engfunc(EngFunc_WriteCoord, originF[1]+30.0)

        engfunc(EngFunc_WriteCoord, originF[2]+40.0)

        message_end()

        

        // Draw explosion

        message_begin(MSG_BROADCAST, SVC_TEMPENTITY)

        write_byte(TE_SPRITE) // Temporary entity ID

        engfunc(EngFunc_WriteCoord, originF[0]) // engfunc because float

        engfunc(EngFunc_WriteCoord, originF[1])

        engfunc(EngFunc_WriteCoord, originF[2]+40.0)

        write_short(g_SprID) // Sprite index

        write_byte(8) // Scale

        write_byte(255) // Framerate

        message_end()



        new a = FM_NULLENT

        while((a = find_ent_in_sphere(a, originF, 60.0)) != 0)

        {

            if (id == a)

                continue 

                

            if(pev(a, pev_takedamage) != DAMAGE_NO)

            {

                ExecuteHamB(Ham_TakeDamage, a, id, id, 50.0, DMG_BULLET)

            }

        }

        return PLUGIN_HANDLED

    }

    return PLUGIN_HANDLED

}



public fw_TakeDamage(victim, inflictor, attacker, Float:damage, ent)

{

    if (victim != attacker && is_user_connected(attacker))

    {

        if(get_user_weapon(attacker) == CSW_G3SG1)

        {

            if(g_has_scsr[attacker])

                SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_scsr))

        }

    }

}



public message_DeathMsg(msg_id, msg_dest, id)

{

    static szTruncatedWeapon[33], iAttacker, iVictim

    

    get_msg_arg_string(4, szTruncatedWeapon, charsmax(szTruncatedWeapon))

    

    iAttacker = get_msg_arg_int(1)

    iVictim = get_msg_arg_int(2)

    

    if(!is_user_connected(iAttacker) || iAttacker == iVictim)

        return PLUGIN_CONTINUE

    

    if(equal(szTruncatedWeapon, "sg550") && get_user_weapon(iAttacker) == CSW_G3SG1)

    {

        if(g_has_scsr[iAttacker])

            set_msg_arg_string(4, "sg550")

    }

    return PLUGIN_CONTINUE

}



stock fm_cs_get_current_weapon_ent(id)

{

    return get_pdata_cbase(id, OFFSET_ACTIVE_ITEM, OFFSET_LINUX)

}



stock fm_cs_get_weapon_ent_owner(ent)

{

    return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS)

}



stock UTIL_PlayWeaponAnimation(const Player, const Sequence)

{

    set_pev(Player, pev_weaponanim, Sequence)

    

    message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = Player)

    write_byte(Sequence)

    write_byte(pev(Player, pev_body))

    message_end()

}



public scsr_ItemPostFrame(weapon_entity) 

{

     new id = pev(weapon_entity, pev_owner)

     if (!is_user_connected(id))

          return HAM_IGNORED



     if (!g_has_scsr[id])

          return HAM_IGNORED



     static iClipExtra

     

     iClipExtra = get_pcvar_num(cvar_clip_scsr)

     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)



     new iBpAmmo = cs_get_user_bpammo(id, CSW_G3SG1)

     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)



     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 



     if(!(get_user_button(id) & IN_ATTACK))

        g_lastexpl[id] = get_gametime()



     if( fInReload && flNextAttack <= 0.0 )

     {

         new j = min(iClipExtra - iClip, iBpAmmo)

    

         set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)

         cs_set_user_bpammo(id, CSW_G3SG1, iBpAmmo-j)

        

         set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)

         fInReload = 0

     }

     return HAM_IGNORED

}



public scsr_Reload(weapon_entity) 

{

     new id = pev(weapon_entity, pev_owner)

     if (!is_user_connected(id))

          return HAM_IGNORED



     if (!g_has_scsr[id])

          return HAM_IGNORED



     static iClipExtra



     if(g_has_scsr[id])

          iClipExtra = get_pcvar_num(cvar_clip_scsr)



     g_scsr_TmpClip[id] = -1



     new iBpAmmo = cs_get_user_bpammo(id, CSW_G3SG1)

     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)



     if (iBpAmmo <= 0)

          return HAM_SUPERCEDE



     if (iClip >= iClipExtra)

          return HAM_SUPERCEDE



     g_scsr_TmpClip[id] = iClip



     return HAM_IGNORED

}



public scsr_Reload_Post(weapon_entity) 

{

    new id = pev(weapon_entity, pev_owner)

    if (!is_user_connected(id))

        return HAM_IGNORED



    if (!g_has_scsr[id])

        return HAM_IGNORED



    if (g_scsr_TmpClip[id] == -1)

        return HAM_IGNORED



    set_pdata_int(weapon_entity, m_iClip, g_scsr_TmpClip[id], WEAP_LINUX_XTRA_OFF)



    set_pdata_float(weapon_entity, m_flTimeWeaponIdle, scsr_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)



    set_pdata_float(id, m_flNextAttack, scsr_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)



    set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)



    UTIL_PlayWeaponAnimation(id, scsr_RELOAD)



    return HAM_IGNORED

}



stock scsr_spr_ball(id, Float:fVec1[3], Float:fVec2[3])

{

    static iVec1[3]

    FVecIVec(fVec1, iVec1)



    static Float:origin[3], Float:vSrc[3], Float:angles[3], Float:v_forward[3], Float:v_right[3], Float:v_up[3], Float:gun_position[3], Float:player_origin[3], Float:player_view_offset[3]

    pev(id, pev_v_angle, angles)

    engfunc(EngFunc_MakeVectors, angles)

    global_get(glb_v_forward, v_forward)

    global_get(glb_v_right, v_right)

    global_get(glb_v_up, v_up)



    //m_pPlayer->GetGunPosition( ) = pev->origin + pev->view_ofs

    pev(id, pev_origin, player_origin)

    pev(id, pev_view_ofs, player_view_offset)

    xs_vec_add(player_origin, player_view_offset, gun_position)



    xs_vec_mul_scalar(v_forward, 24.0, v_forward)

    xs_vec_mul_scalar(v_right, 3.0, v_right)



    if ((pev(id, pev_flags) & FL_DUCKING) == FL_DUCKING)

        xs_vec_mul_scalar(v_up, 6.0, v_up)

    else

        xs_vec_mul_scalar(v_up, -2.0, v_up)



    xs_vec_add(gun_position, v_forward, origin)

    xs_vec_add(origin, v_right, origin)

    xs_vec_add(origin, v_up, origin)



    vSrc[0] = origin[0]

    vSrc[1] = origin[1]

    vSrc[2] = origin[2]



    new Float:dist = get_distance_f(vSrc, fVec2)

    new CountDrops = floatround(dist / 50.0)

    

    if (CountDrops > 20)

        CountDrops = 20

    

    if (CountDrops < 2)

        CountDrops = 2



    message_begin(MSG_PAS, SVC_TEMPENTITY, iVec1)

    write_byte(TE_SPRITETRAIL)

    engfunc(EngFunc_WriteCoord, vSrc[0])

    engfunc(EngFunc_WriteCoord, vSrc[1])

    engfunc(EngFunc_WriteCoord, vSrc[2])

    engfunc(EngFunc_WriteCoord, fVec2[0])

    engfunc(EngFunc_WriteCoord, fVec2[1])

    engfunc(EngFunc_WriteCoord, fVec2[2])

    write_short(scsr_ball)

    write_byte(CountDrops)

    write_byte(0)

    write_byte(1)

    write_byte(60)

    write_byte(10)

    message_end()

}



stock drop_weapons(id, dropwhat)

{

     static weapons[32], num, i, weaponid

     num = 0

     get_user_weapons(id, weapons, num)

     

     for (i = 0; i < num; i++)

     {

          weaponid = weapons[i]

          

          if (dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM))

          {

               static wname[32]

               get_weaponname(weaponid, wname, sizeof wname - 1)

               engclient_cmd(id, "drop", wname)

          }

     }

}